#include <fstream>
#include <iostream>
#include <string>
#include <stdlib.h>


// external vars defined in solve.cpp which are loaded here
extern int    NUM,NUMT,STEPS,UPDATE,SNAPUPDATE,NTRAJ;
extern int    MIMICK2D,RANDOM,RANGEN;
extern int    USEPOLYHEDRA,NW,NPHI,NZ;
extern double A,EPS,XI,MU2,MAXEVIOLATION,TINIT;
extern double TSIG;

using namespace std;

// this workhorse examines a key to see if corresponds to a var we are setting
// and then attempts to set the var corresponding to key by converting value to the
// appropriate type.  lots of hardcoding here
void setParameter(char *key, char *value) {
	// integer params
	if (strcmp(key,"NUM")==0) NUM=atoi(value);
	if (strcmp(key,"TSIG")==0) TSIG=atof(value);
	if (strcmp(key,"TINIT")==0) TINIT=atof(value);
	if (strcmp(key,"NUMT")==0) NUMT=atoi(value);
	if (strcmp(key,"NTRAJ")==0) NTRAJ=atoi(value);
	if (strcmp(key,"MIMICK2D")==0) MIMICK2D=atoi(value);
	if (strcmp(key,"RANDOM")==0) RANDOM=atoi(value);
	if (strcmp(key,"RANGEN")==0) RANGEN=atoi(value);
	if (strcmp(key,"STEPS")==0) STEPS=atoi(value);
	if (strcmp(key,"UPDATE")==0) UPDATE=atoi(value);
	if (strcmp(key,"SNAPUPDATE")==0) SNAPUPDATE=atoi(value);
	if (strcmp(key,"USEPOLYHEDRA")==0) USEPOLYHEDRA=atoi(value);
	if (strcmp(key,"NW")==0) NW=atoi(value);
	if (strcmp(key,"NPHI")==0) NPHI=atoi(value);
	if (strcmp(key,"NZ")==0) NZ=atoi(value);
	// float/double params
	if (strcmp(key,"A")==0) A=atof(value);
	if (strcmp(key,"EPS")==0) EPS=atof(value);
	if (strcmp(key,"XI")==0) XI=atof(value);
	if (strcmp(key,"MU2")==0) MU2=atof(value);
	if (strcmp(key,"MAXEVIOLATION")==0) MAXEVIOLATION=atof(value);
	return;
}

//
// This routine assumes that paramters are in text file with
// each parameter on a new line in the format 
//
// PARAMKEY	PARAMVALUE
//
// The PARAMKEY must begin the line and only tabs and spaces
// can appear between the PARAMKEY and PARAMVALUE.
// 
// Lines which begin with 'commentmarker' defined below are ignored
//
void readParameters(char *filename) {
		
	string commentmarker = "//"; 
	char space = ' '; 
	char tab = '\t';

	int maxline = 128; // maximum line length used in the buffer for reading
	char buffer[maxline];
	ifstream paramFile(filename);
	
	while(!paramFile.eof()) {
		paramFile.getline(buffer,maxline,'\n');
		string line = buffer; int length = strlen(buffer);
		if (line.substr(0,commentmarker.length())!=commentmarker && line.length()>0) {
			char key[32]="",value[32]=""; int founddelim=0;
			for (int i=0;i<length;i++) {
				if (buffer[i]==space || buffer[i]==tab) founddelim=1;
				else {
					if (founddelim==0) key[strlen(key)] = buffer[i];
					else value[strlen(value)] = buffer[i];
				}
			}
			if (strlen(key)>0 && strlen(value)>0) {
				setParameter(key,value);
				cout << key << " = " << value << endl;
			}
		}
	}
	
	// consistency checks
	if ( USEPOLYHEDRA!=1 && (NW != NZ*NPHI)) {
	 	cout << "==> Warning: Inconsistent NW,NZ, and NPHI in parameter file." << endl;
	 	cout << "==> Warning: Adjusting so that NW = NZ*NPHI" << endl;
	 	NW = NZ*NPHI;
	 	cout << "NW = " << NW << endl;
	}
	return;	
}

